
	IDENTIFICATION DIVISION.
	PROGRAM-ID.		VDTTST.
      * SCCS information:
      *@(#) VDTTST  ver. 1.1 last update 85/03/29 12:18:46
      *@(#) This source obtained from the s file on 85/03/29 at 12:19:25
      *			Date Revised  12-FEB-1985.
      *
      *			(TERMINAL CONFIGURATION TEST)
      *
      *			12-Feb-85  1 SUBTRACTed from C for EOS to
      *				prevent scrolling if 24 by 80
      *				chosen in test 5. Notation added
      *				to EOL and EOS tests that they get
      *				their screen dimensions from test 5.
      *				<CR> at command entry now goes to
      *				next test automatically.
      *			30-Oct-84  Version 2 tests added, EOL and EOS
      *				improved, "R" for test repeat added,
      *				beeps on ACCEPTs removed, screen dim-
      *				ension test improved, ON EXECPTION
      *				test clarified.
      *			01-Oct-84  UNIT test removed, spiffy language
      *				changed or removed.
      *
	ENVIRONMENT DIVISION.
	CONFIGURATION SECTION.
	SOURCE-COMPUTER.		RMC.
	OBJECT-COMPUTER.		RMC.
      *
	DATA DIVISION.
	WORKING-STORAGE SECTION.
	01	TITLE.
		03	FILLER		PIC	X(51) VALUE
		"VDTTST: RM/COBOL Verify terminal I/O functions ver.".
		03	TITLE-DATE	PIC	X(10).
		03	TITLE-TIME	PIC	X(8).
	01	VERSION-INFO.
		03	FILLER		PIC	X(15) VALUE "@ #( ) (@)#@(#)".
		03	PROGRAM-NAME	PIC	X(10) VALUE "VDTTST".
		03	FILLER		PIC	X(6) VALUE " ver. ".
		03	VERSION		PIC	X(4)	VALUE "1.1".
		03	VER-DATE	PIC	X(10) VALUE " 85/03/29 ".
		03	VER-TIME	PIC	X(8)	VALUE "12:18:46".
		03	FILLER		PIC	X	VALUE ">".
	77	COMMAND-NUMBER		PIC 99		VALUE ZERO.
	77	LAST-COMMAND		PIC 99		VALUE ZERO.
	77	LAST-COMEDIT		PIC ZZ		VALUE ZERO.
	77	EXC-NUM			PIC 99		VALUE ZERO.
	77	EXC-NUM2		PIC 99		VALUE ZERO.
	77	ONE-CHAR		PIC X		VALUE SPACE.
	77	R			PIC 99		VALUE 24.
	77	C			PIC 999		VALUE 79.
	77	C-DISPLAY		PIC ZZ9		VALUE ZERO.
	77	N			PIC 999		VALUE ZERO.
	77	NAME			PIC X(10)	VALUE SPACES.
	77	LINE-NO			PIC 99		VALUE ZERO.
	77	LINE-NO-EDIT		PIC Z9		VALUE ZERO.
	77	DATE-FLD		PIC 9(6)	VALUE ZERO.
	77	DAY-FLD			PIC 9(5)	VALUE ZERO.
	77	TIME-FLD		PIC 9(8)	VALUE ZERO.
	77	OPERAND			PIC S9(9)V9(9)	VALUE ZERO.
	77	RESULT			PIC -(9)9.9(9)	VALUE ZERO.
	77	COL-ACC			PIC X(150)	VALUE SPACES.
	77	COL-NUM			PIC X(150)	VALUE
	"1234567890123456789012345678901234567890123456789012345678901234
      -"5678901234567890123456789012345678901234567890123456789012345678
      -"9012345678901234567890".
      /
      *
      *
	PROCEDURE DIVISION.
	ENTER-COMMAND.
		MOVE VER-DATE TO TITLE-DATE MOVE VER-TIME TO TITLE-TIME.
		DISPLAY TITLE LINE 1 ERASE.
		DISPLAY " ".
		DISPLAY "       1.  ACCEPT WITH AND WITHOUT PROMPT".
		DISPLAY "       2.  ACCEPT/DISPLAY WITH AND WITHOUT BEEP".
		DISPLAY "       3.  ACCEPT WITH AND WITHOUT TAB".
		DISPLAY "       4.  ACCEPT/DISPLAY WITH DEFAULT VALUES".
		DISPLAY "       5.  CHECK SCREEN DIMENSIONS".
		DISPLAY "       6.  ACCEPT WITH SECURE".
		DISPLAY "       7.  ACCEPT/DISPLAY WITH REVERSE".
		DISPLAY "       8.  ACCEPT DATE & TIME".
		DISPLAY "       9.  HIGH/LOW INTENSITY".
		DISPLAY "       10. ACCEPT WITH BLINK".
		DISPLAY "       11. ACCEPT WITH ON EXCEPTION CLAUSE".
		DISPLAY "       12. ACCEPT WITH UPDATE".
		DISPLAY "       13. ERASE TO END OF LINE".
		DISPLAY "       14. ERASE TO END OF SCREEN".
		DISPLAY "       15. EXIT PROGRAM".
		DISPLAY " ".
		DISPLAY "           ENTER COMMAND NUMBER      ".
		DISPLAY "              LAST COMMAND = ".
		MOVE COMMAND-NUMBER TO LAST-COMMAND, LAST-COMEDIT.
		DISPLAY LAST-COMEDIT POSITION 0.
		DISPLAY "           <CR> GOES TO NEXT TEST.".
	ACCEPT-COMMAND-NUMBER.
		ACCEPT COMMAND-NUMBER LINE 19 POSITION 34
							NO BEEP CONVERT TAB.
		DISPLAY " " LINE 21.
		IF COMMAND-NUMBER EQUAL ZERO
			ADD 1 TO LAST-COMMAND
			MOVE LAST-COMMAND TO COMMAND-NUMBER.
		GO TO TEST-1-PARA,
			TEST-2-PARA,
			TEST-3-PARA,
			TEST-4-PARA,
			TEST-5-PARA,
			TEST-6-PARA,
			TEST-7-PARA,
			TEST-8-PARA,
			TEST-9-PARA,
			TEST-10-PARA,
			TEST-11-PARA,
			TEST-12-PARA,
			TEST-13-PARA,
			TEST-14-PARA,
			EXIT-PARA     DEPENDING ON COMMAND-NUMBER.
		DISPLAY SPACES SIZE 2 LINE 19 POSITION 34.
		GO TO ACCEPT-COMMAND-NUMBER.
      /
      *
      *
	TEST-1-PARA.
		DISPLAY "1. ACCEPT WITH AND WITHOUT PROMPT "
			LINE 1 POSITION 12 ERASE.
      *
		DISPLAY "A.  ACCEPT WITH NO PROMPT" LINE 3.
		DISPLAY "    ENTER YOUR NAME:  " LINE 4.
		ACCEPT NAME LINE 4 POSITION 23 NO BEEP TAB.
		DISPLAY NAME LINE 5 POSITION 23.
      *
		DISPLAY "B.  ACCEPT WITH DEFAULT PROMPT CHARACTER" LINE 7.
		DISPLAY "    ENTER YOUR NAME:  " LINE 8.
		ACCEPT NAME LINE 8 POSITION 23 NO BEEP TAB PROMPT.
		DISPLAY NAME LINE 9 POSITION 23.
      *
		DISPLAY
		"C.  ACCEPT WITH USER-SPECIFIED PROMPT CHARACTER: ""H"""
			LINE 11.
		DISPLAY
		"    ENTER YOUR NAME:  " LINE 12.
		ACCEPT NAME LINE 12 POSITION 23 NO BEEP TAB PROMPT "H"
		DISPLAY NAME LINE 13 POSITION 23.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-1-PARA.
      *
      *
	TEST-2-PARA.
		DISPLAY "2. ACCEPT/DISPLAY WITHOUT AND WITHOUT BEEP"
			LINE 1 POSITION 12 ERASE.
      *
		DISPLAY "A. ACCEPT WITH BEEP (PRESS ""RETURN"")"  LINE 3.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY
			"ENTER YOUR NAME (YOU SHOULD HAVE HEARD A BEEP):  "
			LINE 4 POSITION 4.
		ACCEPT NAME POSITION 0 TAB PROMPT.
      *
		DISPLAY "B. ACCEPT WITHOUT BEEP (PRESS ""RETURN"")" LINE 6.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY
			"ENTER YOUR NAME (YOU SHOULD NOT HAVE HEARD A BEEP):  "
			LINE 7 POSITION 4.
		ACCEPT NAME POSITION 0 TAB PROMPT NO BEEP.
      *
		DISPLAY "C. DISPLAY WITH BEEP (PRESS ""RETURN"")"
			LINE 9.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY "THIS DISPLAY SHOULD HAVE BEEPED."
			LINE 10 POSITION 4 BEEP.
      *
		DISPLAY "D. DISPLAY WITHOUT BEEP (PRESS ""RETURN"")"
			LINE 12.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY "THIS DISPLAY SHOULD NOT HAVE BEEPED."
			LINE 13 POSITION 4.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-2-PARA.
      *
      *
	TEST-3-PARA.
		DISPLAY "3. ACCEPT WITH AND WITHOUT TAB" LINE 1
			POSITION 12 ERASE.
		DISPLAY
		"ENTER A STRING OF 10 CHARS.  AN AUTOMATIC TAB SHOULD"
			LINE 4 POSITION 5.
		DISPLAY "NOT OCCUR AFTER THE LAST CHARACTER IS TYPED."
			LINE 5 POSITION 5.
		ACCEPT NAME LINE 7 POSITION 15
			NO BEEP PROMPT TAB ECHO.
		DISPLAY NAME LINE 8 POSITION 15.
      *
		DISPLAY
		"ENTER A STRING OF 10 CHARS.  AN AUTOMATIC TAB SHOULD"
			LINE 10 POSITION 5.
		DISPLAY "OCCUR AFTER THE LAST CHARACTER HAS BEEN TYPED."
			LINE 11 POSITION 5.
		ACCEPT NAME LINE 13 POSITION 15 PROMPT NO BEEP ECHO.
		DISPLAY NAME LINE 14 POSITION 15.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-3-PARA.
      *
      *
	TEST-4-PARA.
		DISPLAY "4. ACCEPT AND DISPLAY W/ DEFAULT CURSOR POSITION"
			LINE 1 POSITION 12 ERASE.
		DISPLAY "THIS LINE SHOULD START ON LINE 2 POSITION 1."
		DISPLAY "THIS LINE SHOULD START ON LINE 3 POSITION 15."
			POSITION 15.
		DISPLAY "THIS LINE SHOULD START ON LINE 4 POSITION 1."
			LINE 4 POSITION 1.
		DISPLAY "THIS LINE SHOULD START ON LINE 5 POSITION 1."
			LINE 5.
		DISPLAY " THIS LINE SHOULD APPEAR ON LINE 24 POSITION 10."
			LINE 24 POSITION 10.
		DISPLAY "****PRESS ""RETURN"" TO CONTINUE: "
			LINE 12.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP TAB.
      *
		DISPLAY "THIS LINE SHOULD APPEAR ON NEXT LINE POSITION 5."
			POSITION 5.
		DISPLAY "ACCEPT/DISPLAY DEFAULT TEST (POSITION 0) "
			LINE 15 POSITION 5.
		DISPLAY "ENTER FIELD " POSITION 0.
		ACCEPT NAME POSITION 0 PROMPT NO BEEP TAB.
		DISPLAY " ACCEPT AGAIN " POSITION 0.
		ACCEPT NAME POSITION 0 PROMPT NO BEEP TAB.
		DISPLAY " ONE MORE TIME " POSITION 0.
		ACCEPT NAME POSITION 0 PROMPT NO BEEP TAB.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-4-PARA.
      *
      *
	TEST-5-PARA.
		DISPLAY "5. CHECK SCREEN DIMENSIONS (24X79 DEFAULT)"
			LINE 1 POSITION 12 ERASE.
		DISPLAY "HOW MANY HORIZONTAL ROWS ARE THERE ON YOUR CRT? "
			LINE 3 POSITION 5.
		ACCEPT R POSITION 0 TAB NO BEEP.
		IF R = 0 MOVE 24 TO R.
		DISPLAY "HOW MANY VERTICAL COLUMNS? "  LINE 5 POSITION 5.
		ACCEPT C POSITION 0 TAB NO BEEP.
		IF C = 0 MOVE 79 TO C.
		DISPLAY "YOU SHOULD SEE AN ASTERISK IN EACH CORNER"
		LINE 7 POSITION 5.
		DISPLAY "OF SCREEN (AFTER PRESSING ""RETURN"")"
			LINE 8 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY "*" LINE 1 POSITION 1 ERASE.
		DISPLAY "*" LINE R.
		DISPLAY "*" LINE 1 POSITION C.
		DISPLAY "*" LINE R POSITION C.
      *
		DISPLAY "ENTER '0' TO DISPLAY LINE NOS, OTHERWISE 'RETURN'"
		LINE 3 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP TAB.
		IF ONE-CHAR NOT = "0" GO TO COL-DISPLAY.
		MOVE 1 TO LINE-NO.
		MOVE C TO N.
		SUBTRACT 1 FROM N.
		PERFORM DISPLAY-LINE-NO R TIMES.
      *
	COL-DISPLAY.
		DISPLAY "ENTER '1' TO DISPLAY COL-NUM, OTHERWISE 'RETURN'"
			LINE 5 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP TAB.
		IF ONE-CHAR NOT = "1" GO TO ENTER-LINE.
		DISPLAY COL-NUM SIZE C LINE 1 POSITION 1.
		DISPLAY COL-NUM SIZE C LINE R POSITION 1.
      *
	ENTER-LINE.
		DISPLAY "ENTER AN " LINE 7 POSITION 5.
		MOVE C TO C-DISPLAY.
		DISPLAY C-DISPLAY LINE 7 POSITION 0.
		DISPLAY " CHARACTER FIELD TO TEST ACCEPT LIMITS"
			LINE 7 POSITION 0.
		ACCEPT COL-ACC LINE 9 POSITION 1 SIZE C NO BEEP PROMPT TAB.
		DISPLAY COL-ACC LINE 10 SIZE C REVERSE.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-5-PARA.
      *
	DISPLAY-LINE-NO.
		MOVE LINE-NO TO LINE-NO-EDIT.
		DISPLAY LINE-NO, LINE LINE-NO, POSITION 1.
		DISPLAY LINE-NO-EDIT, LINE LINE-NO, POSITION N.
		ADD 1 TO LINE-NO.
      *
      *
	TEST-6-PARA.
		DISPLAY "6. ACCEPT WITH/WITHOUT OFF"
			LINE 1 POSITION 12 ERASE.
		DISPLAY "THIS LINE SHOULD REMAIN UNCHANGED"
			LINE 23 POSITION 5.
		DISPLAY "ENTER YOUR CODE NAME: " LINE 5 POSITION 5.
		ACCEPT NAME POSITION 0 PROMPT NO BEEP TAB OFF.
		DISPLAY "  YOUR CODE NAME WAS: " LINE 7 POSITION 5.
		DISPLAY NAME POSITION 0.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-6-PARA.
      *
      *
	TEST-7-PARA.
		DISPLAY "7. ACCEPT/DISPLAY IN REVERSE"
			LINE 1 POSITION 12 ERASE REVERSE.
		DISPLAY "THIS LINE SHOULD REMAIN UNCHANGED"
			LINE 23 POSITION 5.
		DISPLAY "DISPLAY WITH EXTRA SPACES "
			LINE 5 POSITION 5 REVERSE.
      *
		DISPLAY "ACCEPT IN REVERSE: " LINE 8 POSITION 5.
		ACCEPT NAME POSITION 0 REVERSE NO BEEP TAB.
      *
		DISPLAY "ACCEPT W/PROMPT: " LINE 10 POSITION 5.
		ACCEPT NAME POSITION 0 PROMPT " "
			REVERSE NO BEEP TAB.
      *
		DISPLAY "ACCEPT W/DEF PROMPT: " LINE 12 POSITION 5.
		ACCEPT NAME POSITION 0 PROMPT REVERSE NO BEEP TAB.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-7-PARA.
      *
      *
	TEST-8-PARA.
		DISPLAY "8. ACCEPTING .... FROM DATE, DAY, AND TIME"
			LINE 1 POSITION 12 ERASE.
		ACCEPT DATE-FLD FROM DATE.
		ACCEPT DAY-FLD FROM DAY.
		ACCEPT TIME-FLD FROM TIME.
		DISPLAY " " LINE 2.
		DISPLAY "    TODAY'S DATE IS   (YYMMDD): ", DATE-FLD.
		DISPLAY " ".
		DISPLAY "    THE JULIAN FORM IS (YYDDD): ", DAY-FLD.
		DISPLAY " ".
		DISPLAY "    THE TIME IS     (HHMMSSss): ", TIME-FLD.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-8-PARA.
      *
      *
	TEST-9-PARA.
		DISPLAY "9. HIGH/LOW INTENSITY AND DEFAULT POSITIONING"
			LINE 1 POSITION 12 ERASE.
		DISPLAY "THIS LINE SHOULD REMAIN UNCHANGED"
			LINE 23 POSITION 5.
		DISPLAY "DISPLAY LOW, ACCEPT LOW" LINE 4 POSITION 40.
		DISPLAY "DISPLAY LOW, ACCEPT HIGH" LINE 6 POSITION 40.
		DISPLAY "  W/ DEFAULT POSITIONING" LINE 8 POSITION 40.
      *
		DISPLAY "OPERAND   = " LINE 4 LOW.
		ACCEPT OPERAND LINE 4 POSITION 13 SIZE 9
					TAB NO BEEP PROMPT CONVERT LOW.
		MOVE OPERAND TO RESULT.
		DISPLAY RESULT LINE 4 POSITION 13 LOW.
      *
		DISPLAY "OPERAND   = " LINE 6 LOW.
		ACCEPT OPERAND LINE 6 POSITION 13 SIZE 9
					TAB NO BEEP PROMPT CONVERT HIGH.
		MOVE OPERAND TO RESULT.
		DISPLAY RESULT LINE 6 POSITION 13 LOW.
      *
		DISPLAY "OPERAND   = " LINE 8 LOW.
		ACCEPT OPERAND LINE 8 POSITION 13 SIZE 9
					TAB NO BEEP PROMPT CONVERT HIGH.
		MOVE OPERAND TO RESULT.
		DISPLAY "RESULT = " POSITION 0 LOW.
		DISPLAY RESULT POSITION 0 LOW.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-9-PARA.
      *
      *
	TEST-10-PARA.
		DISPLAY "10. ACCEPT/DISPLAY WITH BLINK"
			LINE 1 POSITION 12 ERASE BLINK.
		DISPLAY " THIS LINE SHOULD REMAIN UNCHANGED"
			LINE 23 POSITION 5.
		DISPLAY " DISPLAY WITH EXTRA SPACES "
			LINE 5 POSITION 5 BLINK REVERSE.
		DISPLAY "BLINK/REVERSE VIDEO" LINE 5 POSITION 40.
		DISPLAY " DISPLAY WITH EXTRA SPACES "
			LINE 7 POSITION 5 LOW BLINK.
		DISPLAY "LOW/BLINK" LINE 7 POSITION 40.
		DISPLAY " WE ARE TESTING ALL THE "
			LINE 9 POSITION 5 LOW REVERSE.
		DISPLAY "LOW/REVERSE VIDEO" LINE 9 POSITION 40.
		DISPLAY " DISPLAY OPTIONS "
			LINE 11 POSITION 5 LOW BLINK REVERSE.
		DISPLAY "LOW/REV/BLINK" LINE 11 POSITION 40.
      *
		DISPLAY " ACCEPT WITH BLINK: " LINE 14 POSITION 5.
		ACCEPT NAME POSITION 0 NO BEEP TAB BLINK.
      *
		DISPLAY " LOW/REV W/PROMPT: " LINE 16 POSITION 5.
		ACCEPT NAME POSITION 0 NO BEEP TAB PROMPT " " LOW REVERSE.
      *
		DISPLAY " BLINK/REV  W/DEF PROMPT: " LINE 18 POSITION 5.
		ACCEPT NAME POSITION 0 NO BEEP TAB PROMPT BLINK REVERSE.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-10-PARA.
      *
      *
	TEST-11-PARA.
		DISPLAY
			"11. ACCEPT WITH ON EXCEPTION CLAUSE AND CONVERT"
			LINE 1 POSITION 12 ERASE.
		MOVE ZEROS TO OPERAND, RESULT.
		DISPLAY
		"ENTER A NUMBER AND TERMINATE W/EXCEPTION CHARACTER:"
			LINE 4 POSITION 5.
		DISPLAY
		"(NON-NUMERIC ENTRY WILL SHOW CONVERT ERROR ""98"")"
			LINE 6 POSITION 5.
		DISPLAY SPACES SIZE 40 LINE 12 POSITION 20.
		ACCEPT OPERAND LINE 8 POSITION 25 SIZE 9
			PROMPT CONVERT NO BEEP TAB
			ON EXCEPTION EXC-NUM
				DISPLAY
					"*** EXCEPTION BRANCH TAKEN ***"
					LINE 12 POSITION 29 BEEP.
		MOVE OPERAND TO RESULT.
		DISPLAY "AS IT WAS ACCEPTED:" LINE 9 POSITION 5.
		DISPLAY RESULT LINE 9 POSITION 24.
		DISPLAY "TERMINATION CODE <  >" LINE 13 POSITION 33.
		DISPLAY EXC-NUM LINE 13 POSITION 51.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-11-PARA.
      *
      *
	TEST-12-PARA.
		DISPLAY "12. ACCEPT WITH UPDATE"
			LINE 1 POSITION 12 ERASE.
		DISPLAY "UPDATE INITIAL FIELD, THEN <RETURN>"
			LINE 3 POSITION 5.
		MOVE "INIT-FIELD" TO NAME.
		ACCEPT NAME LINE 5 POSITION 20 UPDATE NO BEEP TAB.
		DISPLAY "UPDATE CURRENT FIELD, THEN <TAB>"
			LINE 7 POSITION 5.
		ACCEPT NAME LINE 9 POSITION 20 UPDATE NO BEEP TAB.
		DISPLAY "(TRAILING CHARACTERS SHOULD BE BLANK)"
			LINE 11 POSITION 5.
		DISPLAY NAME LINE 13 POSITION 20.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-12-PARA.
      *
      *
	TEST-13-PARA.
		DISPLAY "13. ERASE TO END-OF-LINE"
			LINE 2 POSITION 12 ERASE.
		DISPLAY "(SCREEN DIMENSIONS TAKEN FROM TEST 5.)"
			LINE 3 POSITION 15.
      *
		DISPLAY "ACCEPT WITH EOL." LINE 5 POSITION 5.
		DISPLAY COL-NUM SIZE C LINE 9.
		DISPLAY COL-NUM SIZE C LINE 10.
		DISPLAY "  THIS LINE MUST REMAIN UNCHANGED.  "
			LINE 10 POSITION 3.
		DISPLAY "PRESS ""RETURN"" TO ENTER YOUR NAME W/EOL."
			LINE 7 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		ACCEPT NAME LINE 9 POSITION 5 PROMPT
					NO BEEP ERASE EOL TAB.
      *
		DISPLAY "DISPLAY WITH EOL." LINE 12 POSITION 5.
		DISPLAY COL-NUM SIZE C LINE 16.
		DISPLAY COL-NUM SIZE C LINE 17.
		DISPLAY "  THIS LINE MUST REMAIN UNCHANGED.  "
			LINE 17 POSITION 3.
		DISPLAY "PRESS ""RETURN"" TO DISPLAY W/EOL."
			LINE 14 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY NAME LINE 16 POSITION 5 ERASE EOL.
      *
		PERFORM RETURN-TO-MENU.
		GO TO TEST-13-PARA.
      *
      *
	TEST-14-PARA.
		SUBTRACT 1 FROM C.
		DISPLAY "14. ERASE TO END-OF SCREEN"
			LINE 2 POSITION 12 ERASE.
		DISPLAY "(SCREEN DIMENSIONS TAKEN FROM TEST 5.)"
			LINE 3 POSITION 15.
      *
		DISPLAY "ACCEPT WITH EOS." LINE 5 POSITION 5.
		DISPLAY COL-NUM SIZE C LINE 9.
		MOVE 10 TO N.
		PERFORM THIS-LINE.
		DISPLAY "PRESS ""RETURN"" TO ENTER YOUR NAME W/EOS"
			LINE 7 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		ACCEPT NAME LINE 9 POSITION 5
					NO BEEP PROMPT ERASE EOS TAB.
      *
		DISPLAY "DISPLAY WITH EOS." LINE 12 POSITION 5.
		DISPLAY COL-NUM SIZE C LINE 16.
		MOVE 17 TO N.
		PERFORM THIS-LINE.
		DISPLAY "PRESS ""RETURN"" TO DISPLAY W/EOS"
			LINE 14 POSITION 5.
		ACCEPT ONE-CHAR POSITION 0 NO BEEP.
		DISPLAY NAME LINE 16 POSITION 5 ERASE EOS.
      *
		ADD 1 TO C.
		PERFORM RETURN-TO-MENU.
		GO TO TEST-14-PARA.
      *
	THIS-LINE.
		DISPLAY COL-NUM SIZE C LINE N.
		DISPLAY " THIS LINE MUST BE ERASED. " LINE N POSITION 3.
		ADD 1 TO N.
		IF N NOT GREATER THAN R GO TO THIS-LINE.
      *
      *
	RETURN-TO-MENU.
		MOVE SPACE TO ONE-CHAR.
		DISPLAY "PRESS ""RETURN"" TO RETURN TO MENU.  < >"
			LINE 20 POSITION 26.
		DISPLAY "ENTER AN ""R"" TO REPEAT THIS TEST."
			LINE 21 POSITION 26.
		ACCEPT ONE-CHAR LINE 20 POSITION 62 TAB NO BEEP.
		IF ONE-CHAR = " " GO TO ENTER-COMMAND.
		IF ONE-CHAR NOT EQUAL "R" AND
		ONE-CHAR NOT EQUAL "r" GO TO RETURN-TO-MENU.
      *
      *
	EXIT-PARA.
		EXIT PROGRAM.
      *
      *
	END PROGRAM.
